<%@page contentType="text/html;charset=UTF-8"%>
<%@ taglib prefix="f" uri="http://java.sun.com/jsf/core"%>
<%@ taglib prefix="h" uri="http://java.sun.com/jsf/html"%>
<%@ taglib prefix="s" uri="http://shale.apache.org/core"%>

<%--

 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to you under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.

--%>

<f:view>
	<f:loadBundle var="messages"
		basename="org.apache.shale.usecases.view.Bundle" />
	<html>
	<head>
	<title><h:outputText value="#{messages['usecases.clay']}" /></title>
	</head>
	<body>

	<h:form id="usecasesForm">

		<p>This webapp shows several ways to use Shale Clay to build
		reusable views. It mixes view technologies. This application uses
		several types of templates that are entry points in defining pages 
		(JSP, HTML, and XML). This is most likely not a normal scenario and
		not something natively supported by JavaServer Faces. JSF encourages
		only one type of page entry point.</p>

		<p>All JSF managed views must be dispatched through the faces servlet
		that behaves as the front in controller. JSF also allows you to to
		define the suffix you will be using for your page template technology
		and only one is allowed. Both of these settings are defined in the <h:commandLink action="rolodex$viewsource">
			<f:param name="url" value="/WEB-INF/web.xml" />
			<f:verbatim>[Web deployment descriptor]</f:verbatim>
		</h:commandLink>.</p>
		<p>This application bends the rules using a <a
			href="http://shale.apache.org/features-application-manager.html">Shale
		Application Manager</a> preproces filter <h:commandLink action="rolodex$viewsource">
			<f:param name="url" value="/WEB-INF/chain-config.xml" />
			<f:verbatim>[chain command]</f:verbatim>
		</h:commandLink> to intercept the URI before it is normalized into the
		viewId. The view id identifies the view root. Normally the view Id is
		forced into having the default suffix defined in the <h:commandLink action="rolodex$viewsource">
			<f:param name="url" value="/WEB-INF/web.xml" />
			<f:verbatim>[web.xml]</f:verbatim>
		</h:commandLink>. This is really only important for JSP support. The
		faces servlet needs a url pattern to handle incoming request. This is
		generally suffix mapping of "*.faces". JavaServer Pages conventionally
		have a suffix of ".jsp" and wouldn't be handled correctly by the
		container if they were mapped to a servlet. The default suffix setting
		replaces the suffix of resources that have been handled by the faces
		servlet.</p>
		<p>In most applications you will choose one type of template as your
		page entry point. Therefore, you will only need one servlet mapping and 
		the default suffix parameter should match your servlet mapping choice.</p>

        <p>
		<h:commandLink action="rolodex$viewsource">
				<f:param name="url" value="/rolodex/viewsource.html" />
				<h:outputText value="[View the Viewer's Source]" />
		</h:commandLink>
        </p>

		<h1><h:outputText value="#{messages['usecases.clay']}" /></h1>
		<h:panelGrid columns="2">

			<h:commandLink id="symbols" action="symbols"
				title="#{messages['usecases.symbols.title']}">
				<h:outputText value="#{messages['usecases.symbols']}" />
			</h:commandLink>
			<h:commandLink action="rolodex$viewsource"
				title="#{messages['usecases.rolodex1.title']}">
				<f:param name="url" value="/symbols/home.html" />
				<h:outputText value="#{messages['usecases.rolodex.viewsource']}" />
			</h:commandLink>

			<h:commandLink id="rolodex1" action="rolodex$test1"
				title="#{messages['usecases.rolodex1.title']}">
				<h:outputText value="#{messages['usecases.rolodex1']}" />

			</h:commandLink>
			<h:commandLink action="rolodex$viewsource"
				title="#{messages['usecases.rolodex1.title']}">
				<f:param name="url" value="/rolodex/jsprolodex.jsp" />
				<h:outputText value="#{messages['usecases.rolodex.viewsource']}" />
			</h:commandLink>


			<h:commandLink id="rolodex2" action="rolodex$test2"
				title="#{messages['usecases.rolodex2.title']}">
				<h:outputText value="#{messages['usecases.rolodex2']}" />

			</h:commandLink>
			<h:commandLink action="rolodex$viewsource"
				title="#{messages['usecases.rolodex2.title']}">
				<f:param name="url" value="/rolodex/hrolodex.html" />
				<h:outputText value="#{messages['usecases.rolodex.viewsource']}" />
			</h:commandLink>

			<h:commandLink id="rolodex3" action="rolodex$test3"
				title="#{messages['usecases.rolodex3.title']}">
				<h:outputText value="#{messages['usecases.rolodex3']}" />

			</h:commandLink>
			<h:commandLink action="rolodex$viewsource"
				title="#{messages['usecases.rolodex3.title']}">
				<f:param name="url" value="/rolodex/xhrolodex.html" />
				<h:outputText value="#{messages['usecases.rolodex.viewsource']}" />
			</h:commandLink>

			<h:commandLink id="rolodex4" action="rolodex$test4"
				title="#{messages['usecases.rolodex4.title']}">
				<h:outputText value="#{messages['usecases.rolodex4']}" />

			</h:commandLink>
			<h:commandLink action="rolodex$viewsource"
				title="#{messages['usecases.rolodex4.title']}">
				<f:param name="url" value="/rolodex/rolodex.xml" />
				<h:outputText value="#{messages['usecases.rolodex.viewsource']}" />
			</h:commandLink>

			<h:commandLink id="rolodex5" action="rolodex$test5"
				title="#{messages['usecases.rolodex5.title']}">
				<h:outputText value="#{messages['usecases.rolodex5']}" />
			</h:commandLink>
			<h:commandLink action="rolodex$viewsource"
				title="#{messages['usecases.rolodex5.title']}">
				<f:param name="url" value="/rolodex/jrolodex.html" />
				<h:outputText value="#{messages['usecases.rolodex.viewsource']}" />
			</h:commandLink>

		</h:panelGrid>


	</h:form>

	</body>
	</html>
</f:view>
